Index: trunk/MagicSoft/Mars/mcalib/MCalibrationQEPix.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationQEPix.cc	(revision 5412)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationQEPix.cc	(revision 7829)
@@ -87,6 +87,6 @@
 //     by one of the three methods.
 //
-// 11) A call to GetQECascadesBlindPixel(zenith), GetQECascadesFFactor(zenith) or 
-//     GetQECascadesPINDiode(zenith) returns then the normalization multiplied with an average QE 
+// 11) A call to GetQECascadesBlindPixel(), GetQECascadesFFactor() or
+//     GetQECascadesPINDiode() returns then the normalization multiplied with an average QE
 //     folded into a cascades spectrum. This number should be dependent on zenith angle, but 
 //     this feature is not yet implemented, instead a fixed number gkDefaultAverageQE is used. 
@@ -210,4 +210,5 @@
 const Float_t MCalibrationQEPix::gkLightGuidesEffCT1      = 0.94 ;
 const Float_t MCalibrationQEPix::gkLightGuidesEffCT1Err   = 0.03 ;
+
 // --------------------------------------------------------------------------
 //
@@ -447,10 +448,8 @@
 // -----------------------------------------------------------------
 //
-// Return the average Default QE (depending on zenith angle)
-// FIXME: The zenith angle dependency is not yet implemented
-//
-const Float_t MCalibrationQEPix::GetAverageQE( const Float_t zenith ) const 
-{
-  //  return gkDefaultAverageQE ;
+// Return the average Default QE
+//
+const Float_t MCalibrationQEPix::GetAverageQE() const
+{
   return fAverageQE; 
 }
@@ -458,8 +457,7 @@
 // -----------------------------------------------------------------
 //
-// Return the relative variance of the average Default QE (depending on zenith angle)
-// FIXME: The zenith angle dependency is not yet implemented
-//
-const Float_t MCalibrationQEPix::GetAverageQERelVar( const Float_t zenith ) const 
+// Return the relative variance of the average Default QE
+//
+const Float_t MCalibrationQEPix::GetAverageQERelVar() const
 {
   return gkDefaultAverageQEErr * gkDefaultAverageQEErr / (gkDefaultAverageQE * gkDefaultAverageQE ); 
@@ -469,5 +467,4 @@
 //
 // Return the relative variance of the average normalization (Blind Pixel Method)
-// FIXME: The zenith angle dependency is not yet implemented
 //
 const Float_t MCalibrationQEPix::GetAvNormBlindPixelRelVar( ) const 
@@ -479,5 +476,4 @@
 //
 // Return the relative variance of the average normalization (Combined Method)
-// FIXME: The zenith angle dependency is not yet implemented
 //
 const Float_t MCalibrationQEPix::GetAvNormCombinedRelVar( ) const 
@@ -498,5 +494,4 @@
 //
 // Return the relative variance of the average normalization (PIN Diode Method)
-// FIXME: The zenith angle dependency is not yet implemented
 //
 const Float_t MCalibrationQEPix::GetAvNormPINDiodeRelVar( ) const 
@@ -624,11 +619,10 @@
 // ------------------------------------------------------------------------------
 //
-// Get the light guides efficiency for Cherenkov spectra, 
-// depending on the zenith angle of the telescope
+// Get the light guides efficiency for Cherenkov spectra.
 // FIXME: Lacking detailed measurement, these number are not yet available 
 //        for the individual colours and therefore, only one same number is 
 //        returned, namely gkLightGuidesEffBlue
 //
-Float_t MCalibrationQEPix::GetLightGuidesEff( const Float_t zenith )  const
+Float_t MCalibrationQEPix::GetLightGuidesEff()  const
 {
   return gkLightGuidesEffBlue;
@@ -638,11 +632,10 @@
 // ------------------------------------------------------------------------------
 //
-// Get the relative variance of the light guides efficiency for Cherenkov spectra 
-// depending on the zenith angle of the telescope 
+// Get the relative variance of the light guides efficiency for Cherenkov spectra.
 // FIXME: Lacking detailed measurement, these number are not yet available 
 //        for the individual colours and therefore, only one same number is 
 //        returned, namely gkLightGuidesEffBlueErr^2 / gkLightGuidesBlueEff^2
 //
-Float_t MCalibrationQEPix::GetLightGuidesEffRelVar( const Float_t zenith )  const
+Float_t MCalibrationQEPix::GetLightGuidesEffRelVar()  const
 {
   return gkLightGuidesEffBlueErr  * gkLightGuidesEffBlueErr / gkLightGuidesEffBlue / gkLightGuidesEffBlue;
@@ -846,7 +839,7 @@
 // with the blind pixel method and averaged over the results from the different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesBlindPixel( const Float_t zenith  )  const
-{
-  return fAvNormBlindPixel * GetAverageQE ( zenith );
+Float_t MCalibrationQEPix::GetQECascadesBlindPixel()  const
+{
+  return fAvNormBlindPixel * GetAverageQE();
 }
 
@@ -857,8 +850,8 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesBlindPixelVar( const Float_t zenith  )  const
-{
-  return ( GetAvNormBlindPixelRelVar()  + GetAverageQERelVar(zenith)) 
-    * GetQECascadesBlindPixel(zenith) * GetQECascadesBlindPixel(zenith);
+Float_t MCalibrationQEPix::GetQECascadesBlindPixelVar()  const
+{
+  return ( GetAvNormBlindPixelRelVar()  + GetAverageQERelVar())
+    * GetQECascadesBlindPixel() * GetQECascadesBlindPixel();
 }
 
@@ -869,7 +862,7 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesBlindPixelErr( const Float_t zenith  )  const
-{
-  const Float_t var = GetQECascadesBlindPixelVar(zenith);
+Float_t MCalibrationQEPix::GetQECascadesBlindPixelErr()  const
+{
+  const Float_t var = GetQECascadesBlindPixelVar();
   
   if (var < 0.)
@@ -885,7 +878,7 @@
 // from the different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesCombined( const Float_t zenith  )  const
-{
-  return fAvNormCombined * GetAverageQE ( zenith );
+Float_t MCalibrationQEPix::GetQECascadesCombined() const
+{
+  return fAvNormCombined * GetAverageQE();
 }
 
@@ -896,7 +889,7 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesCombinedErr( const Float_t zenith  )  const
-{
-  const Float_t var = GetQECascadesCombinedVar(zenith);
+Float_t MCalibrationQEPix::GetQECascadesCombinedErr() const
+{
+  const Float_t var = GetQECascadesCombinedVar();
   
   if (var < 0.)
@@ -912,8 +905,8 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesCombinedVar( const Float_t zenith  )  const
-{
-  return ( GetAvNormCombinedRelVar()  + GetAverageQERelVar(zenith)) 
-    * GetQECascadesCombined(zenith) * GetQECascadesCombined(zenith);
+Float_t MCalibrationQEPix::GetQECascadesCombinedVar() const
+{
+  return ( GetAvNormCombinedRelVar()  + GetAverageQERelVar())
+    * GetQECascadesCombined() * GetQECascadesCombined();
 }
 
@@ -923,7 +916,7 @@
 // with the F-Factor method and averaged over the results from the different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesFFactor( const Float_t zenith  )  const
-{
-  return fAvNormFFactor * GetAverageQE ( zenith );
+Float_t MCalibrationQEPix::GetQECascadesFFactor()  const
+{
+  return fAvNormFFactor * GetAverageQE();
 }
 
@@ -934,7 +927,7 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesFFactorErr( const Float_t zenith  )  const
-{
-  const Float_t var = GetQECascadesFFactorVar(zenith);
+Float_t MCalibrationQEPix::GetQECascadesFFactorErr()  const
+{
+  const Float_t var = GetQECascadesFFactorVar();
   
   if (var < 0.)
@@ -950,8 +943,8 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesFFactorVar( const Float_t zenith  )  const
-{
-  return ( GetAvNormFFactorRelVar()  + GetAverageQERelVar(zenith)) 
-    * GetQECascadesFFactor(zenith) * GetQECascadesFFactor(zenith);
+Float_t MCalibrationQEPix::GetQECascadesFFactorVar()  const
+{
+  return ( GetAvNormFFactorRelVar()  + GetAverageQERelVar())
+    * GetQECascadesFFactor() * GetQECascadesFFactor();
 }
 
@@ -961,7 +954,7 @@
 // with the PIN Diode method and averaged over the results from the different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesPINDiode( const Float_t zenith  )  const
-{
-  return fAvNormPINDiode * GetAverageQE ( zenith );
+Float_t MCalibrationQEPix::GetQECascadesPINDiode()  const
+{
+  return fAvNormPINDiode * GetAverageQE();
 }
 
@@ -972,7 +965,7 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesPINDiodeErr( const Float_t zenith  )  const
-{
-  const Float_t var = GetQECascadesPINDiodeVar(zenith);
+Float_t MCalibrationQEPix::GetQECascadesPINDiodeErr() const
+{
+  const Float_t var = GetQECascadesPINDiodeVar();
   
   if (var < 0.)
@@ -988,8 +981,8 @@
 // different colours.
 //
-Float_t MCalibrationQEPix::GetQECascadesPINDiodeVar( const Float_t zenith  )  const
-{
-  return ( GetAvNormPINDiodeRelVar()  + GetAverageQERelVar(zenith)) 
-    * GetQECascadesPINDiode(zenith) * GetQECascadesPINDiode(zenith);
+Float_t MCalibrationQEPix::GetQECascadesPINDiodeVar() const
+{
+  return ( GetAvNormPINDiodeRelVar()  + GetAverageQERelVar())
+    * GetQECascadesPINDiode() * GetQECascadesPINDiode();
 }
 