Index: trunk/MagicSoft/Mars/mbase/BaseLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/BaseLinkDef.h	(revision 7999)
+++ trunk/MagicSoft/Mars/mbase/BaseLinkDef.h	(revision 8011)
@@ -18,4 +18,5 @@
 // I/O
 #pragma link C++ class MZlib+;
+//#pragma link C++ class MBzlib2+;
 
 // Basic Network Tools
@@ -23,4 +24,5 @@
 
 // Basic Tools
+#pragma link C++ namespace MARS;
 #pragma link C++ namespace MMath;
 #pragma link C++ class MString+;
Index: trunk/MagicSoft/Mars/mbase/MAGIC.cc
===================================================================
--- trunk/MagicSoft/Mars/mbase/MAGIC.cc	(revision 8011)
+++ trunk/MagicSoft/Mars/mbase/MAGIC.cc	(revision 8011)
@@ -0,0 +1,59 @@
+/* ======================================================================== *\
+!
+! *
+! * This file is part of MARS, the MAGIC Analysis and Reconstruction
+! * Software. It is distributed to you in the hope that it can be a useful
+! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
+! * It is distributed WITHOUT ANY WARRANTY.
+! *
+! * Permission to use, copy, modify and distribute this software and its
+! * documentation for any purpose is hereby granted without fee,
+! * provided that the above copyright notice appear in all copies and
+! * that both that copyright notice and this permission notice appear
+! * in supporting documentation. It is provided "as is" without express
+! * or implied warranty.
+! *
+!
+!
+!   Author(s): Thomas Bretz  10/2006 <mailto:tbretz@astro.uni-wuerzburg.de>
+!
+!   Copyright: MAGIC Software Development, 2000-2006
+!
+!
+\* ======================================================================== */
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// MARS
+//
+/////////////////////////////////////////////////////////////////////////////
+#include "MAGIC.h"
+
+#include <iostream>
+
+using namespace std;
+
+bool MARS::CheckRootVer()
+{
+    if (!strcmp(gROOT->GetVersion(), ROOT_RELEASE))
+        return true;
+
+    cout << "FATAL ERROR - ROOT version mismatch." << endl;
+    cout << "  Your mars has been compiled using root v" << ROOT_RELEASE << endl;
+    cout << "  The libraries you are using are from root v" << gROOT->GetVersion() << endl;
+    cout << "  Your environment contains:" << endl;
+    cout << "    ROOTSYS         = " << getenv("ROOTSYS") << endl;
+    cout << "    PATH            = " << getenv("PATH") << endl;
+    cout << "    LD_LIBRARY_PATH = " << getenv("LD_LIBRARY_PATH") << endl << endl;
+    cout << "  If this is the right root-version please do" << endl;
+    cout << "    make mrproper && make" << endl;
+    cout << "  for a complete recompilation." << endl << endl;
+    cout << "  If this is the wrong root-version make sure that the file ~/.bashrc contains:" << endl;
+    cout << "    export ROOTSYS=/PathTo/Your/RootVersion" << endl;
+    cout << "    export PATH=$ROOTSYS/bin:$PATH" << endl;
+    cout << "    export LD_LIBRARY_PATH=$ROOTSYS/lib:$LD_LIBRARY_PATH" << endl;
+    cout << "  and start a new shell. Check it by typing \"export\"" << endl;
+    cout << endl;
+
+    return false;
+}
Index: trunk/MagicSoft/Mars/mbase/MAGIC.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MAGIC.h	(revision 7999)
+++ trunk/MagicSoft/Mars/mbase/MAGIC.h	(revision 8011)
@@ -35,3 +35,8 @@
 const Double_t kRad2Deg = 180.0/3.1415926535897932384626433832795028841971693993751;
 
+namespace MARS
+{
+    bool CheckRootVer();
+}
+
 #endif
Index: trunk/MagicSoft/Mars/mbase/MEvtLoop.cc
===================================================================
--- trunk/MagicSoft/Mars/mbase/MEvtLoop.cc	(revision 7999)
+++ trunk/MagicSoft/Mars/mbase/MEvtLoop.cc	(revision 8011)
@@ -109,5 +109,5 @@
     SetBit(kMustCleanup);
 
-    *fLog << inf << underline << "Instantiated MEvtLoop (" << name << "), using ROOT v" << ROOTVER << endl;
+    *fLog << inf << underline << "Instantiated MEvtLoop (" << name << "), using ROOT v" << ROOT_RELEASE << endl;
 }
 
Index: trunk/MagicSoft/Mars/mbase/MStatusDisplay.cc
===================================================================
--- trunk/MagicSoft/Mars/mbase/MStatusDisplay.cc	(revision 7999)
+++ trunk/MagicSoft/Mars/mbase/MStatusDisplay.cc	(revision 8011)
@@ -451,5 +451,5 @@
 
     // Add root version
-    l = new TGLabel(f, MString::Format("Using ROOT v%s", ROOTVER));
+    l = new TGLabel(f, MString::Format("Using ROOT v%s", ROOT_RELEASE));
     fList->Add(l);
 
Index: trunk/MagicSoft/Mars/mbase/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mbase/Makefile	(revision 7999)
+++ trunk/MagicSoft/Mars/mbase/Makefile	(revision 8011)
@@ -18,5 +18,6 @@
 CINT = Base
 
-SRCFILES = MLogo.cc \
+SRCFILES = MAGIC.cc \
+	   MLogo.cc \
            MArgs.cc \
            MString.cc \