Index: trunk/MagicSoft/Mars/mhist/MHCamera.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHCamera.cc	(revision 8104)
+++ trunk/MagicSoft/Mars/mhist/MHCamera.cc	(revision 8106)
@@ -1,3 +1,5 @@
 /* ======================================================================== *\
+! $Name: not supported by cvs2svn $:$Id: MHCamera.cc,v 1.95 2006-10-17 17:16:00 tbretz Exp $
+! --------------------------------------------------------------------------
 !
 ! *
@@ -361,5 +363,5 @@
 // entries with match the given sector are taken into account.
 //
-Stat_t MHCamera::GetMeanSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t all) const
+Stat_t MHCamera::GetMeanSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t ball) const
 {
     if (fNcells<=1)
@@ -371,5 +373,5 @@
     for (int i=0; i<fNcells-2; i++)
     {
-        if ((all || IsUsed(i)) && MatchSector(i, sector, aidx))
+        if ((ball || IsUsed(i)) && MatchSector(i, sector, aidx))
         {
             if (TestBit(kProfile) && fBinEntries[i+1]==0)
@@ -390,5 +392,5 @@
 // entries with match the given sector are taken into account.
 //
-Stat_t MHCamera::GetRmsSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t all) const
+Stat_t MHCamera::GetRmsSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t ball) const
 {
     if (fNcells<=1)
@@ -401,5 +403,5 @@
     for (int i=0; i<fNcells-2; i++)
     {
-        if ((all || IsUsed(i)) && MatchSector(i, sector, aidx))
+        if ((ball || IsUsed(i)) && MatchSector(i, sector, aidx))
         {
             if (TestBit(kProfile) && fBinEntries[i+1]==0)
@@ -429,5 +431,5 @@
 // only pixels with matching sector number are taken into account.
 //
-Double_t MHCamera::GetMinimumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t all) const
+Double_t MHCamera::GetMinimumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t ball) const
 {
     if (fMinimum != -1111)
@@ -445,5 +447,5 @@
 
         const Double_t val = TestBit(kProfile) ? fArray[i+1]/fBinEntries[i+1] : fArray[i+1];
-        if (MatchSector(i, sector, aidx) && (all || IsUsed(i)) && val<minimum)
+        if (MatchSector(i, sector, aidx) && (ball || IsUsed(i)) && val<minimum)
             minimum = val;
     }
@@ -458,5 +460,5 @@
 // only pixels with matching sector number are taken into account.
 //
-Double_t MHCamera::GetMaximumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t all) const
+Double_t MHCamera::GetMaximumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t ball) const
 {
     if (fMaximum!=-1111)
@@ -473,5 +475,5 @@
 
         const Double_t val = TestBit(kProfile) ? fArray[i+1]/fBinEntries[i+1] : fArray[i+1];
-        if (MatchSector(i, sector, aidx) && (all || IsUsed(i)) && val>maximum)
+        if (MatchSector(i, sector, aidx) && (ball || IsUsed(i)) && val>maximum)
             maximum = val;
     }
Index: trunk/MagicSoft/Mars/mhist/MHCamera.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHCamera.h	(revision 8104)
+++ trunk/MagicSoft/Mars/mhist/MHCamera.h	(revision 8106)
@@ -1,2 +1,5 @@
+/* ======================================================================== *\
+!  $Name: not supported by cvs2svn $:$Id: MHCamera.h,v 1.60 2006-10-17 17:16:00 tbretz Exp $
+\* ======================================================================== */
 #ifndef MARS_MHCamera
 #define MARS_MHCamera
@@ -172,6 +175,6 @@
     Stat_t   GetBinError(Int_t binx, Int_t biny, Int_t binz) const { return GetBinError(binx); }
 
-    Double_t GetMinimum(Bool_t all) const { return GetMinimumSectors(TArrayI(), TArrayI(), all); }
-    Double_t GetMaximum(Bool_t all) const { return GetMaximumSectors(TArrayI(), TArrayI(), all); }
+    Double_t GetMinimum(Bool_t ball) const { return GetMinimumSectors(TArrayI(), TArrayI(), ball); }
+    Double_t GetMaximum(Bool_t ball) const { return GetMaximumSectors(TArrayI(), TArrayI(), ball); }
 
     Double_t GetMinimum(Double_t gt) const { return GetMinimumSectors(TArrayI(), TArrayI(), kFALSE); } // FIXME: To be done: Minimum greater than
@@ -181,14 +184,14 @@
     Double_t GetMaximum() const { return GetMaximum(0.0); } // FIXME: To be done: Maximum lower than
 
-    Double_t GetMinimumSector(Int_t sector, Int_t aidx, Bool_t all=kFALSE) const
-    {
-        return GetMinimumSectors(TArrayI(1, &sector), TArrayI(1, &aidx), all);
-    }
-    Double_t GetMaximumSector(Int_t sector, Int_t aidx, Bool_t all=kFALSE) const
-    {
-        return GetMaximumSectors(TArrayI(1, &sector), TArrayI(1, &aidx), all);
-    }
-    Double_t GetMinimumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t all=kFALSE) const;
-    Double_t GetMaximumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t all=kFALSE) const;
+    Double_t GetMinimumSector(Int_t sector, Int_t aidx, Bool_t ball=kFALSE) const
+    {
+        return GetMinimumSectors(TArrayI(1, &sector), TArrayI(1, &aidx), ball);
+    }
+    Double_t GetMaximumSector(Int_t sector, Int_t aidx, Bool_t ball=kFALSE) const
+    {
+        return GetMaximumSectors(TArrayI(1, &sector), TArrayI(1, &aidx), ball);
+    }
+    Double_t GetMinimumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t ball=kFALSE) const;
+    Double_t GetMaximumSectors(const TArrayI &sector, const TArrayI &aidx, Bool_t ball=kFALSE) const;
 
     void     SetLevels(const TArrayF &arr);
@@ -236,6 +239,6 @@
     void     AddNotify(TObject *event);
 
-    Stat_t   GetMean(Bool_t all) const { return GetMeanSectors(TArrayI(), TArrayI(), all); }
-    Stat_t   GetRMS(Bool_t all)  const { return GetRmsSectors(TArrayI(), TArrayI(), all); }
+    Stat_t   GetMean(Bool_t ball) const { return GetMeanSectors(TArrayI(), TArrayI(), ball); }
+    Stat_t   GetRMS(Bool_t ball)  const { return GetRmsSectors(TArrayI(), TArrayI(), ball); }
 
     Stat_t   GetMean(Int_t=0) const { return GetMeanSectors(TArrayI(), TArrayI(), kFALSE); }
@@ -245,11 +248,11 @@
     Stat_t   GetMedianDev() const;
 
-    Stat_t   GetMeanSector(Int_t sector, Int_t aidx, Bool_t all=kFALSE) const
-    {
-        return GetMeanSectors(TArrayI(1, &sector), TArrayI(1, &aidx), all);
-    }
-    Stat_t   GetRmsSector(Int_t sector, Int_t aidx, Bool_t all=kFALSE) const
-    {
-        return GetRmsSectors(TArrayI(1, &sector), TArrayI(1, &aidx), all);
+    Stat_t   GetMeanSector(Int_t sector, Int_t aidx, Bool_t ball=kFALSE) const
+    {
+        return GetMeanSectors(TArrayI(1, &sector), TArrayI(1, &aidx), ball);
+    }
+    Stat_t   GetRmsSector(Int_t sector, Int_t aidx, Bool_t ball=kFALSE) const
+    {
+        return GetRmsSectors(TArrayI(1, &sector), TArrayI(1, &aidx), ball);
     }
 